import 'dart:io';

class Point {
  int i = -1;
  int length = 0;
}

class Dot {
  // ignore: prefer_final_fields
  String _name = "";
  int num = -1;
  Map<int, int> ln = <int, int>{};

  String getName() => _name;
  void setName(String n) => _name = n;
  bool hasConnection(int n) => ln.containsKey(n);
  void addPath(int inp, int length) => ln[inp] = length;
  void delPath(int n) => ln.removeWhere((key, value) => key == n);
  void printD() {
    stdout.write("$_name: №$num => ");
    for (var i in ln.keys) {
      stdout.write("$i|${ln[i]} ");
    }
    stdout.write("\n");
  }

  Dot(String name, int n, List<int> num, List<int> length) {
    _name = name;
    Map<int, int> nw = <int, int>{};
    if (num.length != length.length) {
      print("Error in lists");
    } else {
      for (var i = 0; i <= num.length; i++) {
        nw[num[i]] = length[i];
        ln = nw;
      }
    }
  }

  // Привязка к памяти
  Dot.fromMap(String name, int n, Map<int, int> l) {
    _name = name;
    num = n;
    ln = l;
  }

  // Копирование
  Dot.clone(Dot a) {
    _name = a._name;
    num = a.num;
    ln = a.ln;
  }
}

class Graphs {
  int _amount = 0;
  List<Dot> _dots = <Dot>[];
  // ignore: prefer_final_fields
  Map<int, String> _nameTable = <int, String>{};
  bool useLength = false;
  bool doubleSided = false;

  Graphs(List<Dot> d, bool useL) {
    _dots = d;
    useLength = useL;
    _amount = _dots.length;
    _syncNameTable();
  }

  void _syncNameTable() {
    for (var i in _dots) {
      _nameTable[i.num] = i.getName();
    }
  }

  void _fixPathAfterInsert(Dot a) {
    for (var i in a.ln.keys) {
      if (!_dots[i].ln.containsKey(a.num)) _dots[i].addPath(i, a.ln[i]!);
    }
  }

  bool addDot(Dot a) {
    if (getNumByName(a.getName()) != null) {
      print("Dot name already in use. Change name or use addPath");
      return false;
    }
    _amount++;
    a.num = _amount;
    _dots.add(a);
    _syncNameTable();
    if (doubleSided) _fixPathAfterInsert(a);
    return true;
  }

  bool checkDots() {
    for (var a in _dots) {
      for (var i in a.ln.keys) {
        try {
          if (!_dots[i].ln.containsKey(a.num)) {
            print("Can't find $i");
            return false;
          }
        } catch (e) {
          print(
              "Can't find Dot ${i + 1} for path ${a.num}->${i + 1}. Exception $e");
          return false;
        }
      }
    }
    return true;
  }

  //Getters
  String? getNameByNum(int n) => _nameTable[n];
  int? getNumByName(String n) {
    for (var i in _nameTable.keys) {
      if (_nameTable[i] == n) return i;
    }
    return null;
  }

  //Print info
  void printG() {
    if (doubleSided) {
      print("Не ориентированный");
    } else {
      print("Ориентированный");
    }
    if (useLength) {
      print("Взвешенный");
    } else {
      print("Не взвешенный");
    }
    for (var i in _dots) {
      i.printD();
    }
  }
}
